<script lang="ts">
import Vue from 'vue';
import { SlpHorizontalRule } from '../../common/index.vue';

export default Vue.extend({
  name: 'TopicsHeader',
  components: {
    SlpHorizontalRule,
  },
  props: {
    data: {
      type: Object,
      default: null,
      required: false,
    },
  },
  data() {
    return {
      currentLinkIndex: 0,
    };
  },
});
</script>

<template>
  <SlpRow class="wrapper">
    <SlpColumn :cols="12" class="column">
      <div v-for="(block, index) in data.block" :key="index" class="container">
        <span v-if="block.metadata" :id="block.metadata.id_tag || ''"></span>
        <div
          class="copy"
          :class="{ 'two-col': !block.resources && data.two_col }"
        >
          <SlpTypography tag="h1" variant="heading2" class="copy__title">{{
            data.title || 'Resources'
          }}</SlpTypography>
          <div class="copy__body">
            <div
              v-if="block.text"
              class="slp-mb-32"
              v-html="$md.render(block.text)"
            ></div>
            <a
              v-if="block.link_href"
              :href="block.link_href"
              :data-ga-name="block.data_ga_name"
              :data-ga-location="block.data_ga_location || 'header'"
              class="copy__link slp-btn"
              >{{ block.link_text }}
            </a>
          </div>
        </div>
        <div v-if="block.resources" class="topics">
          <div
            v-for="(resource, propertyName, resourceIndex) in block.resources"
            :key="propertyName"
            class="slp-flex slp-flex-column topics__column"
          >
            <SlpTypography tag="h4" variant="body1" class="topics__header">
              {{ resource.header }}
            </SlpTypography>
            <!-- eslint-disable vue/no-template-shadow -->
            <a
              v-for="(link, index) in resource.links"
              :key="`${propertyName}-${index}`"
              :href="link.link"
              :data-ga-name="link.data_ga_name"
              :data-ga-location="link.data_ga_location"
            >
              <!-- eslint-enable vue/no-template-shadow -->
              {{ link.text }}
            </a>
            <SlpHorizontalRule
              v-if="Object.keys(block.resources).length - 1 !== resourceIndex"
            />
          </div>
        </div>
      </div>
    </SlpColumn>
    <hr class="divider" />
  </SlpRow>
</template>

<style lang="scss" scoped>
.wrapper {
  margin-top: $spacing-64;
}
.container {
  display: flex;
  padding: 0 $spacing-16;
  grid-gap: $spacing-16;
  margin: 0 auto;
  position: relative;

  hr {
    margin: $spacing-32 0;
    grid-column: 1 / span 12;
  }

  &__corner-img {
    position: absolute;
    left: -$spacing-64;
    top: -$spacing-24;
    &--two-col {
      top: -$spacing-48;
      left: -$spacing-96;
    }
  }
  @media (max-width: $breakpoint-lg) {
    flex-direction: column;
  }
}

.copy {
  grid-column: 1 / 12;
  margin-right: $spacing-64;
  font-size: 23px !important;
  @media (max-width: $breakpoint-md) {
    text-align: center;
  }

  @media (max-width: $breakpoint-lg) {
    margin-right: 0;
  }

  @media (max-width: $breakpoint-md) {
    text-align: center;
  }

  &:not(.two-col) {
    max-width: 66.66667%;

    @media (max-width: $breakpoint-lg) {
      margin-right: 0;
      max-width: 100%;
    }
  }

  @media (min-width: $breakpoint-xl) {
    grid-column: 1 / 6;
  }

  &__title {
    margin-bottom: $spacing-32;
    z-index: 0;

    &:before,
    &:after {
      position: absolute;
      width: 180px;
      height: 180px;
      content: '';
      z-index: -1;
    }
  }
  h4 {
    color: $color-text-300;
    font-size: 23px;
    font-weight: 400;
    line-height: 20px;
    margin-bottom: $spacing-16;

    @media (min-width: $breakpoint-xl) {
      line-height: 28px;
    }
  }

  &__body {
    grid-column: 1 / 12;
    color: $color-text-300;
    line-height: 30px;

    &:deep p {
      font-size: 23px;
    }

    &:deep li {
      font-size: 16px;
    }

    &:deep p a {
      color: $color-text-link-100;
      font-size: 23px !important;
    }
  }

  &__link {
    display: block;
    text-decoration: none;
    color: $color-text-link-100;
    &:hover {
      text-decoration: underline;
    }

    &:after {
      position: absolute;
      content: '→';
      padding-top: 2px;
      padding-left: $spacing-4;
      width: $spacing-8;
    }
  }
  &:hover {
    text-decoration: none;
  }

  &--active {
    padding-right: $spacing-96;
    font-weight: 600;

    &:after {
      width: 86px;
    }

    &--active:after,
    &:hover:after,
    &:active:after {
      background-color: $color-secondary-200;
      height: 2px;
      transition: all ease-in 0.2s;
    }
  }

  &.two-col {
    display: flex;
    justify-content: space-between;
    flex-wrap: wrap;

    .copy__title {
      flex: 41.66%;
    }

    .copy__body {
      flex: 58.34%;
    }

    @media (max-width: 959px) {
      .copy__title {
        flex: 100%;
      }

      .copy__body {
        flex: 100%;
      }
    }
  }

  @media (max-width: $breakpoint-sm) {
    &__title h1 {
      font-size: 36px;
      line-height: 44px;
    }
  }
}

.topics {
  grid-column: 1 / 12;
  height: 100%;
  padding-left: $spacing-64;
  border: 0;
  border-left-color: currentcolor;
  border-left-style: none;
  border-left-width: 0;
  border-left: 1px solid #e7e7e7;

  @media (min-width: $breakpoint-lg) {
    grid-column: 7 / span 6;
  }

  @media (max-width: $breakpoint-lg) {
    padding-top: $spacing-24;
  }

  &__header {
    font-weight: 600;
    text-transform: uppercase;
  }

  a {
    position: relative;
    padding-bottom: $spacing-24;
    text-decoration: none;
    font-size: 16px;
    line-height: 20px;
    cursor: pointer;
    transition: all ease-in 0.2s;

    &:after {
      content: '→';
      opacity: 0;
      transition: 0.25s;
    }

    &:hover:after {
      opacity: 1;
    }
  }
}

.divider {
  width: 100%;
  margin: $spacing-24 0 $spacing-48 0;
  border: 0;
  border-top-color: currentcolor;
  border-top-style: none;
  border-top-width: 0;
  border-top: 1px solid #e7e7e7;
}
</style>
